<?php
/**
 * Created by PhpStorm.
 * Script Name: Bbase.php
 * Create: 2021/12/21 12:37
 * Description: 客户功能基础类
 * Author: fudaoji<fdj@kuryun.cn>
 */

namespace app\admin\controller;
use app\constants\Media;

class Bbase extends Base
{
    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
    }

    /**
     * 设置一条或者多条数据的状态
     * @Author  fudaoji<fdj@kuryun.cn>
     */
    public function setStatusBak() {
        $ids = input('ids/a');
        $status = input('status');

        if (empty($ids)) {
            $this->error('请选择要操作的数据');
        }

        $ids = (array) $ids;
        foreach ($ids as $id){
            $this->model->delOne(['id' => $id, 'admin_id' => $this->adminInfo['id']]);
        }
        $this->success('删除成功');
    }

    /**
     * 设置一条或者多条数据的状态
     * @Author  fudaoji<fdj@kuryun.cn>
     */
    public function setStatus() {
        $ids = input('ids/a');
        $status = input('status');

        if (empty($ids)) {
            $this->error('请选择要操作的数据');
        }

        $ids = (array) $ids;
        if($status == 'delete'){
            foreach ($ids as $id){
                $this->model->delOne(['id' => $id, 'admin_id' => $this->adminInfo['id']]);
            }
        }else{
            $arr = [];
            $msg = [
                'success' => '操作成功！',
                'error'   => '操作失败！',
            ];
            switch ($status) {
                case 'forbid' :  // 禁用条目
                    $data['status'] = 0;
                    break;
                case 'resume' :  // 启用条目
                    $data['status'] = 1;
                    break;
                case 'hide' :  // 隐藏条目
                    $data['status'] = 2;
                    break;
                case 'show' :  // 显示条目
                    $data['status'] = 1;
                    break;
                case 'recycle' :  // 移动至回收站
                    $data['status'] = 1;
                    break;
                case 'restore' :  // 从回收站还原
                    $data['status'] = 1;
                    break;
                default:
                    $this->error('参数错误');
                    break;
            }
            foreach($ids as $id){
                $data[$this->pk] = $id;
                $data['admin_id'] = $this->adminInfo['id'];
                $arr[] = $data;
            }
            if($this->model->updateBatch($arr)){
                $this->success($msg['success']);
            }else{
                $this->error($msg['error']);
            }
        }
    }

    /**
     * 保存数据
     * @param string $jump_to
     * @param array $data
     * @return mixed
     */
    public function savePost($jump_to = '', $data=[]){
        $post_data = $data ? $data : input('post.');
        $post_data['admin_id'] = $this->adminInfo['id'];
        if(empty($post_data[$this->pk])){
            $res = $this->model->addOne($post_data);
        }else {
            $res = $this->model->updateOne($post_data);
        }

        if($res){
            $this->success('数据保存成功', $jump_to);
        }else{
            $this->error('数据保存出错');
        }
    }

    public function mediaTabs(){
        return [
            Media::TEXT => ['title' => '文本', 'href' => url('mediatext/index')],
            Media::IMAGE => ['title' => '图片', 'href' => url('mediaimage/index')],
            Media::FILE => ['title' => '文件', 'href' => url('mediafile/index')],
            Media::VIDEO => ['title' => '视频', 'href' => url('mediavideo/index')],
            Media::LINK => ['title' => '分享链接', 'href' => url('medialink/index')]
        ];
    }
}